/* libsizzle/dynlib.h - shared library handling functions
 
  Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_DYNLIB_H__
#define __SIZZLE_DYNLIB_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

/* This is non-zero if dynamic linking support is available.  */
SIZZLE_API extern int zzz_config_have_dl;

#if ENABLE_DL

#define dynlib_p(c)       (tagged_p(c) && \
                           tagged_type(c) == zzz_tagged_type_dynlib)
#define dynlib_handle(c)  ((void *) (tagged_data0(c)))

/* Tagged type for dynamic library objects.  */
SIZZLE_API extern unsigned long zzz_tagged_type_dynlib;

/* Create a dynamic library object called @var{name} for the handler
   @var{handle}.  */
SIZZLE_API zzz_scm_t zzz_make_dynlib (void * handle, zzz_scm_t name);

/* Initialize the dynamic library module.  */
SIZZLE_API result_t zzz_init_dynlib (void);

#endif /* ENABLE_DL */

#endif /* not __SIZZLE_DYNLIB_H__ */
