/* libsizzle/pointer.h - pointer handling primitive procedures
 
  Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_POINTER_H__
#define __SIZZLE_POINTER_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

#include "result.h"

/* Mark the pointer object @var{pointer} as being invalid, so that
   functions expecting valid pointer objects will barf when
   @var{pointer} is passed to them in the future.  */
SIZZLE_API void zzz_invalidate_pointer (zzz_scm_t pointer);

/* Initialize the pointer module.  */
SIZZLE_API result_t zzz_init_pointer (void);

#endif /* not __SIZZLE_POINTER_H__ */
