/* libsizzle/promise.h - promise handling -- delay/force
 
  Copyright (C) 1999, 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_PROMISE_H__
#define __SIZZLE_PROMISE_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

#include "node.h"

#define promise_p(c)      (tagged_p(c) && \
                           tagged_type(c) == zzz_tagged_type_promise)
#define promise_env(c)    (((promise_desc_t) tagged_data0(c))->environment)
#define promise_result(c) (((promise_desc_t) tagged_data0(c))->result)
#define promise_expr(c)   (((promise_desc_t) tagged_data0(c))->expression)
#define promise_thawed(c) (((promise_desc_t) tagged_data0(c))->thawed)

typedef struct promise_descriptor * promise_desc_t;
struct promise_descriptor
{
  zzz_scm_t environment;
  int thawed;
  zzz_scm_t result;
  zzz_scm_t expression;
};

SIZZLE_API zzz_scm_t zzz_make_promise (zzz_scm_t env, zzz_scm_t expression);
SIZZLE_API result_t zzz_init_promise (void);

#endif /* not __SIZZLE_PROMISE_H__ */
