/* libsizzle/values.h - multiple value handling
 
  Copyright (C) 1999, 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
 
  This is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This software is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this package; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.  */

#ifndef __SIZZLE_VALUES_H__
#define __SIZZLE_VALUES_H__

#if HAVE_CONFIG_H
# include <config.h>
#endif 

#if __SIZZLE_IMPORT__
# define SIZZLE_API __declspec (dllimport)
#elif __SIZZLE_EXPORT__ 
# define SIZZLE_API __declspec (dllexport)
#else
# define SIZZLE_API
#endif

#include "node.h"

/* Discriminator and accessor macros for the multiple values data type.  */
#define values_p(c)   (tagged_p(c) &&\
                       tagged_type(c) == zzz_tagged_type_values)
#define values_val(c) ((zzz_scm_t) tagged_data0(c))

/* Tagged type for multiple values objects.  */
SIZZLE_API extern zzz_object_t zzz_tagged_type_values;

/* Create a multiple values objects representing the values in
   @var{values}, which must be a list.  */
SIZZLE_API zzz_scm_t zzz_make_values (zzz_scm_t values);

/* Initialize the multiple values module.  Must be called before using
   any multiple values, because the values type is registered here.  */
SIZZLE_API result_t zzz_init_values (void);

#endif /* not __SIZZLE_VALUES_H__ */
